//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "better.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RefreshList()
{//refresh the display of the list to reflect the current data
JonsClass *jClass;
int Counter = MyList->Count, Temp;

Temp = ListBox1->ItemIndex;
ListBox1->Items->Clear();

for(int x = 0; x < Counter; x++)
    {
    jClass = dynamic_cast <JonsClass *> (MyList->Items[x]);
    if(jClass)
        {
        ListBox1->Items->Add(FormatDateTime("dd mmm yyyy hh:mm:ss", jClass->MyDateTime));
        }
    }

if((Temp > 0) && (Temp <= ListBox1->Items->Count))
    ListBox1->ItemIndex = Temp;
else
    ListBox1->ItemIndex = -1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
MyList = new jClassList;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
delete MyList;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{//save the list to file
jSaveToFile("notes.jsk", MyList->SaveToStream);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
//load the list
MyList->Clear();
jLoadFromFile("notes.jsk", MyList->LoadFromStream);
RefreshList();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
//add a new entry to the list
MyList->Add(new JonsClass);
RefreshList();    
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
//set the entry for the highlighted object in the list
JonsClass *Temp;    //pointer only no delete
try
    {
    Temp = dynamic_cast <JonsClass *> (MyList->Items[ListBox1->ItemIndex]);
    if(Temp)
        Temp->MyString = Memo1->Text;

    }
catch(...)
    {//simple save
    ShowMessage("Invalid entry highlighted");
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListBox1Click(TObject *Sender)
{
//display the entry
JonsClass *Temp;    //pointer only no delete

try
    {
    Temp = dynamic_cast <JonsClass *> (MyList->Items[ListBox1->ItemIndex]);
    if(Temp)
        {
        Label1->Caption = FormatDateTime("dd mmm yyyy hh:mm:ss", Temp->MyDateTime);
        Memo1->Text = Temp->MyString;
        }
    }
catch(...)
    {
    ShowMessage("Invalid entry?");
    }
}
//---------------------------------------------------------------------------
